import clutter
import os
import sys
import time
import gobject
import dbus
from clutter import cogl

class slideshower:
	def __init__(self):
		global num
		global timeline
		
		self.stage = clutter.Stage()
		
		num = 1
		try:
			timedelay = float(sys.argv[1])
		except:
			timedelay = 1.49
		try:
			path = sys.argv[2]
		except:
			path = "/home/user/MyDocs/.images"
		try:
			mode = sys.argv[3]
		except:
			mode = "black"
			
		images = os.listdir(path)
		for i in images:
			if not i.split(".")[-1] in ["jpg", "jpeg", "png"]:
				del images[images.index(i)]
		if not path[-1]=="/":
			path = path+"/"
			
		image1 = clutter.Texture(path+images[0])
		image2 = clutter.Texture(path+images[1])
		image1.set_size(800, 480)
		image2.set_size(800, 480)
		
		timeline = clutter.Timeline(duration=3000)
		alpha = clutter.Alpha(timeline, clutter.LINEAR)
		if mode=="fade" or mode=="black":
			behaviour = clutter.BehaviourOpacity(0, 0xff, alpha)
			behaviour.apply(image2)
		elif mode=="spin":
			pass
			#behaviour = clutter.BehaviourScale(0, 0, 1, 1, alpha)
			#behaviour.set_center(400, 240, 0)
			#behaviour.set_axis(clutter.Z_AXIS)
			#behaviour.apply(image2)
			#behaviour1 = clutter.BehaviourPath(alpha)
			#behaviour1.append_knots((800,0), (0,0))
			#behaviour1.apply(image2)
		# start the timeline running, thus starting the animation
		timeline.start()
		timeline.set_loop(True)
		self.stage.set_fullscreen(True)
		color = clutter.Color(0, 0, 0)
		self.stage.set_color(color)		
		def go_fullscreen():
			self.stage.set_fullscreen(True)
		
		def startupagain():
			timeline.start()
			self.stage.remove(image3)
			
		
		def next_image(a, self):
			self.mceRequest.req_display_blanking_pause()
			try:
				global num
				global timeline
				global image3
				if mode == "fade":
					timeline.stop()
					image3 = clutter.Texture(path+images[num])
					image3.set_size(800, 480)
					self.stage.add(image3)
					self.stage.show_all()
					image1.set_from_file(path+images[num])
					num+=1
					if num>len(images):
						num=0
					image2.set_from_file(path+images[num])
					gobject.timeout_add(timedelay*1000, startupagain)
				elif mode == "black":
					try:
						self.stage.remove(image1)
					except:
						pass
					if timeline.get_direction()==clutter.TIMELINE_FORWARD:
						timeline.pause()
						gobject.timeout_add(timedelay*1000, timeline.start)
						timeline.set_direction(clutter.TIMELINE_BACKWARD)
					else:
						timeline.set_direction(clutter.TIMELINE_FORWARD)
						num+=1
						if num>len(images):
							num=0
						image2.set_from_file(path+images[num])
				elif mode == "spin":
					timeline.stop()
					image1.set_from_file(path+images[num])
					image1.set_rotation(clutter.Y_AXIS, 0, 400, 0, 0)
					image1.show()
					num+=1
					if num>len(images):
						num=0
					image2.hide()
					image2.set_from_file(path+images[num])
					def spin (val):
						global num
						if val<90:
							image2.hide()
							image1.show()
							image1.set_rotation(clutter.Y_AXIS, val, 400, 0, 0)
						else:
							image1.hide()
							image2.show()
							image2.set_rotation(clutter.Y_AXIS, val-180, 400, 0, 0)
						if val<180:
							source_id = gobject.timeout_add(40, spin, val+5)
						else:
							source_id = gobject.timeout_add(1000*timedelay, next_image, a, self)
							
					val = 0
					source_id = gobject.timeout_add(40, spin, val)
					
			except KeyboardInterrupt:
				clutter.main_quit()
		    # screen blanking related
		self.bus = dbus.SystemBus()
		self.mceRequest = self.bus.get_object('com.nokia.mce','/com/nokia/mce/request')
		self.mceSignal = self.bus.get_object('com.nokia.mce','/com/nokia/mce/signal')
		self.mceSignalInterface = dbus.Interface(self.mceSignal,'com.nokia.mce.signal')
		#self.mceSignalInterface.connect_to_signal("display_status_ind", self.screenStateChangedCallback)
		print "N900: dbus initialized"
				
		
		self.stage.add(image1)
		self.stage.add(image2)
		self.stage.show_all()
		self.stage.connect('destroy', clutter.main_quit)
		self.stage.connect('button-press-event', clutter.main_quit)
		timeline.connect('completed', next_image, self)
		gobject.timeout_add(10, go_fullscreen)
		clutter.main()
if __name__=="__main__":
	a = slideshower()